










































































	.text
	.align	16, 0x90
	.globl	__gmpn_mullow_n_basecase
	.type	__gmpn_mullow_n_basecase,@function
__gmpn_mullow_n_basecase:

	cmp	$4, %rcx
	jge	lgen
	mov	(%rsi), %rax		
	mov	(%rdx), %r8		

	lea	ltab(%rip), %r9
	movslq	(%r9,%rcx,4), %r10
	add	%r10, %r9
	jmp	*%r9

	.section .data.rel.ro.local,"aw",@progbits
	.align	8, 0x90
ltab:	.long  ltab-ltab
			
	.long  l1-ltab
			
	.long  l2-ltab
			
	.long  l3-ltab
			
	.text

l1:	imul	%r8, %rax
	mov	%rax, (%rdi)
	ret

l2:	mov	8(%rdx), %r11
	imul	%rax, %r11		
	mul	%r8			
	mov	%rax, (%rdi)
	imul	8(%rsi), %r8		
	lea	(%r11, %rdx), %rax
	add	%r8, %rax
	mov	%rax, 8(%rdi)
	ret

l3:	mov	8(%rdx), %r9	
	mov	16(%rdx), %r11
	mul	%r8			
	mov	%rax, (%rdi)		
	mov	(%rsi), %rax		
	mov	%rdx, %rcx		
	mul	%r9			
	imul	8(%rsi), %r9		
	mov	16(%rsi), %r10
	imul	%r8, %r10		
	add	%rax, %rcx
	adc	%rdx, %r9
	add	%r10, %r9
	mov	8(%rsi), %rax		
	mul	%r8			
	add	%rax, %rcx
	adc	%rdx, %r9
	mov	%r11, %rax
	imul	(%rsi), %rax		
	add	%rax, %r9
	mov	%rcx, 8(%rdi)
	mov	%r9, 16(%rdi)
	ret

l0m4:
l1m4:
l2m4:
l3m4:
lgen:	push	%rbx
	push	%rbp
	push	%r13
	push	%r14
	push	%r15

	mov	(%rsi), %rax
	mov	(%rdx), %r13
	mov	%rdx, %r11

	lea	(%rdi,%rcx,8), %rdi
	lea	(%rsi,%rcx,8), %rsi
	neg	%rcx

	mul	%r13

	test	$1, %cl
	jz	lmul_2

lmul_1:
	lea	-8(%rdi), %rdi
	lea	-8(%rsi), %rsi
	test	$2, %cl
	jnz	lmul_1_prologue_3

lmul_1_prologue_2:		
	lea	-1(%rcx), %r9
	lea	laddmul_outer_1(%rip), %r8
	mov	%rax, %rbx
	mov	%rdx, %r15
	xor	%ebp, %ebp
	xor	%r10d, %r10d
	mov	16(%rsi,%rcx,8), %rax
	jmp	lmul_1_entry_2

lmul_1_prologue_3:		
	lea	1(%rcx), %r9
	lea	laddmul_outer_3(%rip), %r8
	mov	%rax, %rbp
	mov	%rdx, %r10
	xor	%ebx, %ebx
	jmp	lmul_1_entry_0

	.align	16, 0x90
lmul_1_top:
	mov	%rbx, -16(%rdi,%r9,8)
	add	%rax, %r15
	mov	(%rsi,%r9,8), %rax
	adc	%rdx, %rbp
	xor	%ebx, %ebx
	mul	%r13
	mov	%r15, -8(%rdi,%r9,8)
	add	%rax, %rbp
	adc	%rdx, %r10
lmul_1_entry_0:
	mov	8(%rsi,%r9,8), %rax
	mul	%r13
	mov	%rbp, (%rdi,%r9,8)
	add	%rax, %r10
	adc	%rdx, %rbx
	mov	16(%rsi,%r9,8), %rax
	mul	%r13
	mov	%r10, 8(%rdi,%r9,8)
	xor	%ebp, %ebp	
	mov	%rbp, %r10			
	add	%rax, %rbx
	mov	24(%rsi,%r9,8), %rax
	mov	%rbp, %r15			
	adc	%rdx, %r15
lmul_1_entry_2:
	mul	%r13
	add	$4, %r9
	js	lmul_1_top

	mov	%rbx, -16(%rdi)
	add	%rax, %r15
	mov	%r15, -8(%rdi)
	adc	%rdx, %rbp

	imul	(%rsi), %r13
	add	%r13, %rbp
	mov	%rbp, (%rdi)

	add	$1, %rcx
	jz	lret

	mov	8(%r11), %r13
	mov	16(%r11), %r14

	lea	16(%rsi), %rsi
	lea	8(%r11), %r11
	lea	24(%rdi), %rdi

	jmp	*%r8


lmul_2:
	mov	8(%r11), %r14
	test	$2, %cl
	jz	lmul_2_prologue_3

	.align	16, 0x90
lmul_2_prologue_1:
	lea	0(%rcx), %r9
	mov	%rax, %r10
	mov	%rdx, %rbx
	xor	%r15d, %r15d
	mov	(%rsi,%rcx,8), %rax
	lea	laddmul_outer_3(%rip), %r8
	jmp	lmul_2_entry_1

	.align	16, 0x90
lmul_2_prologue_3:
	lea	2(%rcx), %r9
	mov	$0, %r10d
	mov	%rax, %r15
	mov	(%rsi,%rcx,8), %rax
	mov	%rdx, %rbp
	lea	laddmul_outer_1(%rip), %r8
	jmp	lmul_2_entry_3

	.align	16, 0x90
lmul_2_top:
	mov	-32(%rsi,%r9,8), %rax
	mul	%r14
	add	%rax, %rbx
	adc	%rdx, %r15
	mov	-24(%rsi,%r9,8), %rax
	xor	%ebp, %ebp
	mul	%r13
	add	%rax, %rbx
	mov	-24(%rsi,%r9,8), %rax
	adc	%rdx, %r15
	adc	$0, %ebp
	mul	%r14
	add	%rax, %r15
	mov	%rbx, -24(%rdi,%r9,8)
	adc	%rdx, %rbp
	mov	-16(%rsi,%r9,8), %rax
	mul	%r13
	mov	$0, %r10d
	add	%rax, %r15
	adc	%rdx, %rbp
	mov	-16(%rsi,%r9,8), %rax
	adc	$0, %r10d
lmul_2_entry_3:
	mov	$0, %ebx
	mov	%r15, -16(%rdi,%r9,8)
	mul	%r14
	add	%rax, %rbp
	mov	-8(%rsi,%r9,8), %rax
	adc	%rdx, %r10
	mov	$0, %r15d
	mul	%r13
	add	%rax, %rbp
	mov	-8(%rsi,%r9,8), %rax
	adc	%rdx, %r10
	adc	%r15d, %ebx
	mul	%r14
	add	%rax, %r10
	mov	%rbp, -8(%rdi,%r9,8)
	adc	%rdx, %rbx
	mov	(%rsi,%r9,8), %rax
	mul	%r13
	add	%rax, %r10
	adc	%rdx, %rbx
	adc	$0, %r15d
lmul_2_entry_1:
	add	$4, %r9
	mov	%r10, -32(%rdi,%r9,8)
	js	lmul_2_top

	imul	-16(%rsi), %r14
	add	%r14, %rbx
	imul	-8(%rsi), %r13
	add	%r13, %rbx
	mov	%rbx, -8(%rdi)

	add	$2, %rcx
	jz	lret

	mov	16(%r11), %r13
	mov	24(%r11), %r14

	lea	16(%r11), %r11
	lea	16(%rdi), %rdi

	jmp	*%r8


laddmul_outer_1:
	lea	-2(%rcx), %r9
	mov	-16(%rsi,%rcx,8), %rax
	mul	%r13
	mov	%rax, %r10
	mov	-16(%rsi,%rcx,8), %rax
	mov	%rdx, %rbx
	xor	%r15d, %r15d
	lea	laddmul_outer_3(%rip), %r8
	jmp	laddmul_entry_1

laddmul_outer_3:
	lea	0(%rcx), %r9
	mov	-16(%rsi,%rcx,8), %rax
	xor	%r10d, %r10d
	mul	%r13
	mov	%rax, %r15
	mov	-16(%rsi,%rcx,8), %rax
	mov	%rdx, %rbp
	lea	laddmul_outer_1(%rip), %r8
	jmp	laddmul_entry_3

	.align	16, 0x90
laddmul_top:
	add	%r10, -32(%rdi,%r9,8)
	adc	%rax, %rbx
	mov	-24(%rsi,%r9,8), %rax
	adc	%rdx, %r15
	xor	%ebp, %ebp
	mul	%r13
	add	%rax, %rbx
	mov	-24(%rsi,%r9,8), %rax
	adc	%rdx, %r15
	adc	%ebp, %ebp
	mul	%r14
	xor	%r10d, %r10d
	add	%rbx, -24(%rdi,%r9,8)
	adc	%rax, %r15
	mov	-16(%rsi,%r9,8), %rax
	adc	%rdx, %rbp
	mul	%r13
	add	%rax, %r15
	mov	-16(%rsi,%r9,8), %rax
	adc	%rdx, %rbp
	adc	$0, %r10d
laddmul_entry_3:
	mul	%r14
	add	%r15, -16(%rdi,%r9,8)
	adc	%rax, %rbp
	mov	-8(%rsi,%r9,8), %rax
	adc	%rdx, %r10
	mul	%r13
	xor	%ebx, %ebx
	add	%rax, %rbp
	adc	%rdx, %r10
	mov	$0, %r15d
	mov	-8(%rsi,%r9,8), %rax
	adc	%r15d, %ebx
	mul	%r14
	add	%rbp, -8(%rdi,%r9,8)
	adc	%rax, %r10
	adc	%rdx, %rbx
	mov	(%rsi,%r9,8), %rax
	mul	%r13
	add	%rax, %r10
	mov	(%rsi,%r9,8), %rax
	adc	%rdx, %rbx
	adc	$0, %r15d
laddmul_entry_1:
	mul	%r14
	add	$4, %r9
	js	laddmul_top

	add	%r10, -32(%rdi)
	adc	%rax, %rbx

	imul	-24(%rsi), %r13
	add	%r13, %rbx
	add	%rbx, -24(%rdi)

	add	$2, %rcx
	jns	lret

	lea	16(%r11), %r11

	mov	(%r11), %r13
	mov	8(%r11), %r14

	lea	-16(%rsi), %rsi

	jmp	*%r8

lret:	pop	%r15
	pop	%r14
	pop	%r13
	pop	%rbp
	pop	%rbx
	ret
	.size	__gmpn_mullow_n_basecase,.-__gmpn_mullow_n_basecase
