








































































































	.text
	.align	16, 0x90
	.globl	__gmpn_sqr_basecase_skylake_avx
	.type	__gmpn_sqr_basecase_skylake_avx,@function
__gmpn_sqr_basecase_skylake_avx:

	

	cmp	$2, %rdx
	jae	.Lgt1

	mov	(%rsi), %rdx
	mulx %rdx,%rax,%rdx
	mov	%rax, (%rdi)
	mov	%rdx, 8(%rdi)
	
	ret

.Lgt1:	jne	.Lgt2

	mov	(%rsi), %rdx
	mov	8(%rsi), %rcx
	mulx %rcx,%r9,%r10	
	mulx %rdx,%rax,%r8	
	mov	%rcx, %rdx
	mulx %rdx,%r11,%rdx	
	add	%r9, %r9		
	adc	%r10, %r10		
	adc	$0, %rdx		
	add	%r9, %r8		
	adc	%r11, %r10		
	adc	$0, %rdx		
	mov	%rax, (%rdi)
	mov	%r8, 8(%rdi)
	mov	%r10, 16(%rdi)
	mov	%rdx, 24(%rdi)
	
	ret

.Lgt2:	cmp	$4, %rdx
	jae	.Lgt3

	push	%rbx
	mov	(%rsi), %rdx
	mulx 8(%rsi),%r10,%r11
	mulx 16(%rsi),%r8,%r9
	add	%r11, %r8
	mov	8(%rsi), %rdx
	mulx 16(%rsi),%rax,%r11
	adc	%rax, %r9
	adc	$0, %r11
	test	%ebx, %ebx
	mov	(%rsi), %rdx
	mulx %rdx,%rbx,%rcx
	mov	%rbx, (%rdi)
	mov	8(%rsi), %rdx
	mulx %rdx,%rax,%rbx
	mov	16(%rsi), %rdx
	mulx %rdx,%rsi,%rdx
	adcx %r10,%r10
	adcx %r8,%r8
	adcx %r9,%r9
	adcx %r11,%r11
	adox %r10,%rcx
	adox %r8,%rax
	adox %r9,%rbx
	adox %r11,%rsi
	mov	$0, %r8d
	adox %r8,%rdx
	adcx %r8,%rdx
	mov	%rcx, 8(%rdi)
	mov	%rax, 16(%rdi)
	mov	%rbx, 24(%rdi)
	mov	%rsi, 32(%rdi)
	mov	%rdx, 40(%rdi)
	pop	%rbx
	
	ret

.Lgt3:	push	%rbx

	push	%rdi
	push	%rsi
	push	%rdx

	lea	-3(%rdx), %ebx
	lea	5(%rdx), %rcx
	mov	%edx, %eax
	and	$-8, %ebx
	shr	$3, %ecx		
	neg	%rbx			
	and	$7, %eax		

	mov	(%rsi), %rdx

	lea	.Lmtab(%rip), %r10
	movslq	(%r10,%rax,4), %r8
	lea	(%r8, %r10), %r10
	jmp	*%r10


.Lmf0:	mulx 8(%rsi),%r10,%r11
	lea	64(%rsi), %rsi

	jmp	.Lmb0

.Lmf3:	mulx 8(%rsi),%r8,%r9
	lea	24(%rsi), %rsi
	lea	24(%rdi), %rdi
	jmp	.Lmb3

.Lmf4:	mulx 8(%rsi),%r10,%r11
	lea	32(%rsi), %rsi
	lea	32(%rdi), %rdi
	jmp	.Lmb4

.Lmf5:	mulx 8(%rsi),%r8,%r9
	lea	40(%rsi), %rsi
	lea	40(%rdi), %rdi
	jmp	.Lmb5

.Lmf6:	mulx 8(%rsi),%r10,%r11
	lea	48(%rsi), %rsi
	lea	48(%rdi), %rdi
	jmp	.Lmb6

.Lmf7:	mulx 8(%rsi),%r8,%r9
	lea	56(%rsi), %rsi
	lea	56(%rdi), %rdi
	jmp	.Lmb7

.Lmf1:	mulx 8(%rsi),%r8,%r9
	lea	8(%rsi), %rsi
	lea	8(%rdi), %rdi
	jmp	.Lmb1

.Lmf2:	mulx 8(%rsi),%r10,%r11
	lea	16(%rsi), %rsi
	lea	16(%rdi), %rdi
	dec	%ecx
	mulx (%rsi),%r8,%r9

	.align	16, 0x90
.Ltop:	mov	%r10, -8(%rdi)
	adc	%r11, %r8
.Lmb1:	mulx 8(%rsi),%r10,%r11
	adc	%r9, %r10
	lea	64(%rsi), %rsi
	mov	%r8, (%rdi)
.Lmb0:	mov	%r10, 8(%rdi)
	mulx -48(%rsi),%r8,%r9
	lea	64(%rdi), %rdi
	adc	%r11, %r8
.Lmb7:	mulx -40(%rsi),%r10,%r11
	mov	%r8, -48(%rdi)
	adc	%r9, %r10
.Lmb6:	mov	%r10, -40(%rdi)
	mulx -32(%rsi),%r8,%r9
	adc	%r11, %r8
.Lmb5:	mulx -24(%rsi),%r10,%r11
	mov	%r8, -32(%rdi)
	adc	%r9, %r10
.Lmb4:	mulx -16(%rsi),%r8,%r9
	mov	%r10, -24(%rdi)
	adc	%r11, %r8
.Lmb3:	mulx -8(%rsi),%r10,%r11
	adc	%r9, %r10
	mov	%r8, -16(%rdi)
	dec	%ecx
	mulx (%rsi),%r8,%r9
	jnz	.Ltop

.Lend:	mov	%r10, -8(%rdi)
	adc	%r11, %r8
	mov	%r8, (%rdi)
	adc	%rcx, %r9
	mov	%r9, 8(%rdi)

	lea	.Latab(%rip), %r10
	movslq	(%r10,%rax,4), %r11
	lea	(%r11, %r10), %r11
	jmp	*%r11


.Led0:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf7:	lea	-64(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	mov	8(%rsi), %rdx
	mulx 16(%rsi),%r8,%r9
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb7

	.align	16, 0x90
.Ltp0:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led0
	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
.Lb0:	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp0

.Led1:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf0:	lea	-64(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	mov	(%rsi), %rdx
	mulx 8(%rsi),%r10,%r11
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb0

	.align	16, 0x90
.Ltp1:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led1
.Lb1:	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp1

.Led2:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf1:	lea	(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	lea	8(%rbx), %rbx
	mov	-8(%rsi), %rdx
	mulx (%rsi),%r8,%r9
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb1

	.align	16, 0x90
.Ltp2:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led2
	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp2

.Led3:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf2:	lea	(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	jz	.Lcorner2
	mov	-16(%rsi), %rdx
	mulx -8(%rsi),%r10,%r11
	lea	8(%rdi,%rbx,8), %rdi
	mulx (%rsi),%r8,%r9
	jmp	.Ltp2

	.align	16, 0x90
.Ltp3:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led3
	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
.Lb3:	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp3

.Led4:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf3:	lea	(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	jz	.Lcorner3
	mov	-24(%rsi), %rdx
	mulx -16(%rsi),%r8,%r9
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb3

	.align	16, 0x90
.Ltp4:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led4
	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
.Lb4:	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp4

.Led5:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf4:	lea	(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	mov	-32(%rsi), %rdx
	mulx -24(%rsi),%r10,%r11
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb4

	.align	16, 0x90
.Ltp5:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led5
	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
.Lb5:	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp5

.Led6:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf5:	lea	(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	mov	-40(%rsi), %rdx
	mulx -32(%rsi),%r8,%r9
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb5

	.align	16, 0x90
.Ltp6:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led6
	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
.Lb6:	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp6

.Led7:	adox (%rdi),%r8
	adox %rcx,%r9		
	mov	%r8, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)
.Lf6:	lea	(%rsi,%rbx,8), %rsi
	or	%ebx, %ecx
	mov	-48(%rsi), %rdx
	mulx -40(%rsi),%r10,%r11
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb6

	.align	16, 0x90
.Ltp7:	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	jrcxz	.Led7
	mulx 8(%rsi),%r10,%r11
	adox (%rdi),%r8
	lea	8(%rcx), %ecx
	mov	%r8, (%rdi)
	adcx %r9,%r10
	mulx 16(%rsi),%r8,%r9
	adcx %r11,%r8
	adox 8(%rdi),%r10
	mov	%r10, 8(%rdi)
.Lb7:	mulx 24(%rsi),%r10,%r11
	lea	64(%rsi), %rsi
	adcx %r9,%r10
	adox 16(%rdi),%r8
	mov	%r8, 16(%rdi)
	mulx -32(%rsi),%r8,%r9
	adox 24(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 24(%rdi)
	mulx -24(%rsi),%r10,%r11
	adcx %r9,%r10
	adox 32(%rdi),%r8
	mov	%r8, 32(%rdi)
	mulx -16(%rsi),%r8,%r9
	adox 40(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, 40(%rdi)
	adox 48(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	jmp	.Ltp7

.Lcorner3:
	mov	-24(%rsi), %rdx
	mulx -16(%rsi),%r8,%r9
	adox -8(%rdi),%r8
	mulx -8(%rsi),%r10,%r11
	mov	%r8, -8(%rdi)
	lea	8(%rdi), %rdi
	adcx %r9,%r10
	mulx (%rsi),%r8,%r9
	adox -8(%rdi),%r10
	adcx %r11,%r8
	mov	%r10, -8(%rdi)
	adox (%rdi),%r8
	adox %rcx,%r9		
	adcx %rcx,%r9		
.Lcorner2:
	mov	-16(%rsi), %rdx
	mulx -8(%rsi),%r10,%r11
	mulx (%rsi),%rax,%rbx
	adox %r8,%r10
	adcx %r11,%rax
	mov	%r10, (%rdi)
	adox %r9,%rax
	adox %rcx,%rbx		
	mov	%rax, 8(%rdi)
	adc	%rcx, %rbx		
	mov	-8(%rsi), %rdx
	mulx (%rsi),%rax,%rdx
	add	%rbx, %rax
	mov	%rax, 16(%rdi)
	adc	%rcx, %rdx		
	mov	%rdx, 24(%rdi)

.Lsqr_diag_addlsh1:
	pop	%rcx
	pop	%rsi
	pop	%rdi






	dec	%ecx
	mov	(%rsi), %rdx
	xor	%ebx, %ebx	
	mulx %rdx,%rax,%r10
	mov	%rax, (%rdi)
	mov	8(%rdi), %r8
	mov	16(%rdi), %r9
	jmp	.Ldm

	.align	16, 0x90
.Ldtop:mov	24(%rdi), %r8
	mov	32(%rdi), %r9
	lea	16(%rdi), %rdi
	lea	(%rdx,%rbx), %r10
.Ldm:	adc	%r8, %r8
	adc	%r9, %r9
	setc	%bl
	mov	8(%rsi), %rdx
	lea	8(%rsi), %rsi
	mulx %rdx,%rax,%rdx
	add	%r10, %r8
	adc	%rax, %r9
	mov	%r8, 8(%rdi)
	mov	%r9, 16(%rdi)
	dec	%ecx
	jnz	.Ldtop

.Ldend:adc	%rbx, %rdx
	mov	%rdx, 24(%rdi)




	pop	%rbx
	
	ret

	.section .data.rel.ro.local,"aw",@progbits
	.align	8, 0x90
.Lmtab:.long  .Lmf7-.Lmtab

	.long  .Lmf0-.Lmtab

	.long  .Lmf1-.Lmtab

	.long  .Lmf2-.Lmtab

	.long  .Lmf3-.Lmtab

	.long  .Lmf4-.Lmtab

	.long  .Lmf5-.Lmtab

	.long  .Lmf6-.Lmtab

.Latab:.long  .Lf6-.Latab

	.long  .Lf7-.Latab

	.long  .Lf0-.Latab

	.long  .Lf1-.Latab

	.long  .Lf2-.Latab

	.long  .Lf3-.Latab

	.long  .Lf4-.Latab

	.long  .Lf5-.Latab

	.text
	.size	__gmpn_sqr_basecase_skylake_avx,.-__gmpn_sqr_basecase_skylake_avx


