



































































































	.text
	.align	16, 0x90
	.globl	__gmpn_mul_basecase_skylake_avx
	.type	__gmpn_mul_basecase_skylake_avx,@function
__gmpn_mul_basecase_skylake_avx:


	cmp	$2, %rdx
	ja	.Lgen
	mov	(%rcx), %rdx
	mulx	(%rsi), %rax, %r9		
	je	.Ls2x

.Ls11:	mov	%rax, (%rdi)
	mov	%r9, 8(%rdi)
	
	ret

.Ls2x:	cmp	$2, %r8
	mulx	8(%rsi), %r8, %r10	
	je	.Ls22

.Ls21:	add	%r8, %r9
	adc	$0, %r10
	mov	%rax, (%rdi)
	mov	%r9, 8(%rdi)
	mov	%r10, 16(%rdi)
	
	ret

.Ls22:	add	%r8, %r9		
	adc	$0, %r10		
	mov	8(%rcx), %rdx
	mov	%rax, (%rdi)
	mulx	(%rsi), %r8, %r11		
	mulx	8(%rsi), %rax, %rdx	
	add	%r11, %rax		
	adc	$0, %rdx		
	add	%r8, %r9		
	adc	%rax, %r10		
	adc	$0, %rdx		
	mov	%r9, 8(%rdi)
	mov	%r10, 16(%rdi)
	mov	%rdx, 24(%rdi)
	
	ret

	.align	16, 0x90
.Lgen:
	push	%rbx
	push	%rbp
	push	%r12
	push	%r14

	mov	%rcx, %r14
	lea	1(%rdx), %rbx
	mov	%rdx, %rbp
	mov	%edx, %eax
	and	$-8, %rbx
	shr	$3, %rbp		
	neg	%rbx
	and	$7, %eax		
					
	mov	%rbp, %rcx
	mov	(%r14), %rdx
	lea	8(%r14), %r14

	lea	.Lmtab(%rip), %r10
	movslq	(%r10,%rax,4), %r11
	lea	(%r11, %r10), %r10
	jmp	*%r10


.Lmf0:	mulx	(%rsi), %r10, %r11
	lea	56(%rsi), %rsi
	lea	-8(%rdi), %rdi
	jmp	.Lmb0

.Lmf3:	mulx	(%rsi), %r12, %r9
	lea	16(%rsi), %rsi
	lea	16(%rdi), %rdi
	inc	%rcx
	jmp	.Lmb3

.Lmf4:	mulx	(%rsi), %r10, %r11
	lea	24(%rsi), %rsi
	lea	24(%rdi), %rdi
	inc	%rcx
	jmp	.Lmb4

.Lmf5:	mulx	(%rsi), %r12, %r9
	lea	32(%rsi), %rsi
	lea	32(%rdi), %rdi
	inc	%rcx
	jmp	.Lmb5

.Lmf6:	mulx	(%rsi), %r10, %r11
	lea	40(%rsi), %rsi
	lea	40(%rdi), %rdi
	inc	%rcx
	jmp	.Lmb6

.Lmf7:	mulx	(%rsi), %r12, %r9
	lea	48(%rsi), %rsi
	lea	48(%rdi), %rdi
	inc	%rcx
	jmp	.Lmb7

.Lmf1:	mulx	(%rsi), %r12, %r9
	jmp	.Lmb1

.Lmf2:	mulx	(%rsi), %r10, %r11
	lea	8(%rsi), %rsi
	lea	8(%rdi), %rdi
	mulx	(%rsi), %r12, %r9

	.align	16, 0x90
.Lm1top:
	mov	%r10, -8(%rdi)
	adc	%r11, %r12
.Lmb1:	mulx	8(%rsi), %r10, %r11
	adc	%r9, %r10
	lea	64(%rsi), %rsi
	mov	%r12, (%rdi)
.Lmb0:	mov	%r10, 8(%rdi)
	mulx	-48(%rsi), %r12, %r9
	lea	64(%rdi), %rdi
	adc	%r11, %r12
.Lmb7:	mulx	-40(%rsi), %r10, %r11
	mov	%r12, -48(%rdi)
	adc	%r9, %r10
.Lmb6:	mov	%r10, -40(%rdi)
	mulx	-32(%rsi), %r12, %r9
	adc	%r11, %r12
.Lmb5:	mulx	-24(%rsi), %r10, %r11
	mov	%r12, -32(%rdi)
	adc	%r9, %r10
.Lmb4:	mulx	-16(%rsi), %r12, %r9
	mov	%r10, -24(%rdi)
	adc	%r11, %r12
.Lmb3:	mulx	-8(%rsi), %r10, %r11
	adc	%r9, %r10
	mov	%r12, -16(%rdi)
	dec	%rcx
	mulx	(%rsi), %r12, %r9
	jnz	.Lm1top

.Lm1end:
	mov	%r10, -8(%rdi)
	adc	%r11, %r12
	mov	%r12, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)

	dec	%r8
	jz	.Ldone

	lea	.Latab(%rip), %r10
	movslq	(%r10,%rax,4), %rax
	lea	(%rax, %r10), %rax


.Louter:
	lea	(%rsi,%rbx,8), %rsi
	mov	%rbp, %rcx
	mov	(%r14), %rdx
	lea	8(%r14), %r14
	jmp	*%rax

.Lf0:	mulx	8(%rsi), %r10, %r11
	lea	8(%rdi,%rbx,8), %rdi
	lea	-1(%rcx), %rcx
	jmp	.Lb0

.Lf3:	mulx	-16(%rsi), %r12, %r9
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb3

.Lf4:	mulx	-24(%rsi), %r10, %r11
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb4

.Lf5:	mulx	-32(%rsi), %r12, %r9
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb5

.Lf6:	mulx	-40(%rsi), %r10, %r11
	lea	-56(%rdi,%rbx,8), %rdi
	jmp	.Lb6

.Lf7:	mulx	16(%rsi), %r12, %r9
	lea	8(%rdi,%rbx,8), %rdi
	jmp	.Lb7

.Lf1:	mulx	(%rsi), %r12, %r9
	lea	8(%rdi,%rbx,8), %rdi
	jmp	.Lb1

.Lam1end:
	adox	(%rdi), %r12
	adox	%rcx, %r9		
	mov	%r12, (%rdi)
	adc	%rcx, %r9		
	mov	%r9, 8(%rdi)

	dec	%r8			
	jnz	.Louter
.Ldone:
	pop	%r14
	pop	%r12
	pop	%rbp
	pop	%rbx
	
	ret

.Lf2:
	mulx	-8(%rsi), %r10, %r11
	lea	8(%rdi,%rbx,8), %rdi
	mulx	(%rsi), %r12, %r9

	.align	16, 0x90
.Lam1top:
	adox	-8(%rdi), %r10
	adcx	%r11, %r12
	mov	%r10, -8(%rdi)
	jrcxz	.Lam1end
.Lb1:	mulx	8(%rsi), %r10, %r11
	adox	(%rdi), %r12
	lea	-1(%rcx), %rcx
	mov	%r12, (%rdi)
	adcx	%r9, %r10
.Lb0:	mulx	16(%rsi), %r12, %r9
	adcx	%r11, %r12
	adox	8(%rdi), %r10
	mov	%r10, 8(%rdi)
.Lb7:	mulx	24(%rsi), %r10, %r11
	lea	64(%rsi), %rsi
	adcx	%r9, %r10
	adox	16(%rdi), %r12
	mov	%r12, 16(%rdi)
.Lb6:	mulx	-32(%rsi), %r12, %r9
	adox	24(%rdi), %r10
	adcx	%r11, %r12
	mov	%r10, 24(%rdi)
.Lb5:	mulx	-24(%rsi), %r10, %r11
	adcx	%r9, %r10
	adox	32(%rdi), %r12
	mov	%r12, 32(%rdi)
.Lb4:	mulx	-16(%rsi), %r12, %r9
	adox	40(%rdi), %r10
	adcx	%r11, %r12
	mov	%r10, 40(%rdi)
.Lb3:	adox	48(%rdi), %r12
	mulx	-8(%rsi), %r10, %r11
	mov	%r12, 48(%rdi)
	lea	64(%rdi), %rdi
	adcx	%r9, %r10
	mulx	(%rsi), %r12, %r9
	jmp	.Lam1top

	.section .data.rel.ro.local,"aw",@progbits
	.align	8, 0x90
.Lmtab:.long  .Lmf0-.Lmtab

	.long  .Lmf1-.Lmtab

	.long  .Lmf2-.Lmtab

	.long  .Lmf3-.Lmtab

	.long  .Lmf4-.Lmtab

	.long  .Lmf5-.Lmtab

	.long  .Lmf6-.Lmtab

	.long  .Lmf7-.Lmtab

.Latab:.long  .Lf0-.Latab

	.long  .Lf1-.Latab

	.long  .Lf2-.Latab

	.long  .Lf3-.Latab

	.long  .Lf4-.Latab

	.long  .Lf5-.Latab

	.long  .Lf6-.Latab

	.long  .Lf7-.Latab

	.text
	.size	__gmpn_mul_basecase_skylake_avx,.-__gmpn_mul_basecase_skylake_avx


